# coding: utf-8

"""
    Conekta API

    Conekta sdk  # noqa: E501

    The version of the OpenAPI document: 2.1.0
    Contact: engineering@conekta.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class WebhookKeyCreateResponse(BaseModel):
    """
    webhook keys model
    """
    active: Optional[StrictBool] = Field(None, description="Indicates if the webhook key is active")
    created_at: Optional[StrictInt] = Field(None, description="Unix timestamp in seconds with the creation date of the webhook key")
    id: Optional[StrictStr] = Field(None, description="Unique identifier of the webhook key")
    livemode: Optional[StrictBool] = Field(None, description="Indicates if the webhook key is in live mode")
    object: Optional[StrictStr] = Field(None, description="Object name, value is webhook_key")
    public_key: Optional[StrictStr] = Field(None, description="Public key to be used in the webhook")
    __properties = ["active", "created_at", "id", "livemode", "object", "public_key"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WebhookKeyCreateResponse:
        """Create an instance of WebhookKeyCreateResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WebhookKeyCreateResponse:
        """Create an instance of WebhookKeyCreateResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return WebhookKeyCreateResponse.parse_obj(obj)

        _obj = WebhookKeyCreateResponse.parse_obj({
            "active": obj.get("active"),
            "created_at": obj.get("created_at"),
            "id": obj.get("id"),
            "livemode": obj.get("livemode"),
            "object": obj.get("object"),
            "public_key": obj.get("public_key")
        })
        return _obj

